#include "project.h"

#include <stdio.h>

// Setup stdout console primitive (enable direct, i.e. printf, etc)
int _write(int file, char *ptr, int len) {
    int i;

    file = file;

    for (i = 0; i < len; i++) {
        while (! CNSL_CDCIsReady()) { }
        CNSL_PutChar(*ptr++);
    }
    return len;
}


#define USBUART_BUFFER_SIZE     (64u)

// Setup stdin console primitive (enable direct, i.e. scanf, getchar, etc)
int _read(int file, char *ptr, int len) {
    int count;
    uint8 rbuf[USBUART_BUFFER_SIZE];

    file = file;

    // Raw Mode
    if (! CNSL_GetConfiguration()) { return EOF; }
    if (! CNSL_DataIsReady()) { return EOF; }

    count = CNSL_GetAll(rbuf);
    
    if (! count) { return 0; }

    if (len < count) { count = len; }
    
    memcpy(ptr, rbuf, count);
    
    return count;
}

/* [prim_io.c] END OF FILE */
